<?

/* this library has several useful function to handle some basic functions
such as, read a directory, read a file, make a dynamic image */



/* read a directory and return the list of files contained by it (with some
file classement and management
$repertoire = complete path of the directory to read 
*/

function lire_repertoire ($repertoire)
{
   $rh = opendir ($repertoire);
   
   while ($value = readdir($rh))
   {
       $tout[] = $value;
       
       if (test_source($value))
       {
           $source[] = $value;
       }
       elseif (is_dir($value) && (strcmp($value,"images") != 0))
       {
           $repertoire_tab[] = $value;
       }
       elseif (test_template($value))
       {
           $template[] = $value;
       }
   }
   
   closedir($rh);
   
   $retour['repertoire'] = $repertoire_tab;
   $retour['source'] = $source;
   $retour['template'] = $template;
   $retour['tout'] = $tout;
   
   return ($retour);
}


function test_source ($nom)
{
   return (eregi ("htmlsrc$",$nom) ? true : false);
}


// test if the file $nom is a template (.tpl)
function test_template ($nom)
{
   return(eregi ("tpl$",$nom) ? true : false);
}

/* read the content of the file $fichier */
function lire_fichier ($fichier)
{
   $fh = fopen($fichier,'r');
   
   $contenu = fread ($fh,filesize($fichier));
   
   fclose ($fh);
   
   return ($contenu);
}

/* this function is used to create an image from a string. 
$source = the path of the source image where we will write something on it
$string = the string we will write on the image
$font = the path of the font we will use
$longueur = the wanting length of the image
$largeur = the wanting height of the image
$couleur = the color of the string
*/

function creation_image ($source,$string,$font,$longueur,$largeur,$couleur)
{
/* we create a transparent rectangular image with the given length and
height */
   $image = imagecreate ($longueur,$largeur);
   
   /* we import the source image */
   $image_source = imagecreatefromgif ($source);
   
   /* and we get his length and width */
   $dimension = getimagesize($image_source);
   
   /* we create the white color */
   $blanc = imagecolorallocate ($image,255,255,255);
   /* we create the color of the string */
   $couleur = imagecolorallocate ($image,$couleur[0],$couleur[1],$couleur[2]);
   
   /* we say ... white is transparent */
   imagecolortransparent ($image,$blanc);
   
   /* we reduce to the wanted length and width the source image, and we copy
it to the newly created image */
   imagecopyresized($image,$image_source,0,0,0,0,$longueur,$largeur,$dimension[0],$dimension[1]);
   
   /* we destroy the image source */
   imagedestroy ($image_source);
   
   /* we draw our string on the image */
   imagestring ($image,$font,2,2,$string,$couleur);
   
   /* we compute the new path we use for the newly created image */
   $nom = eregi_replace (" ","_",$string);
   $lien = "$DOCUMENT_ROOT/shared/$nom.gif";
   
   /* we stored it */
   imagegif ($image,$lien);
   
   /* and we destroy it from the memory */
   imagedestroy ($image);
}

/* it's used to add a little blank space at the end of the page. For more
leasability purpose */

function faire_blanc ($contenu)
{
    $blanc = "\n\n\n\n";
    
    return ($blanc . $contenu);
}

/* it's used to get the content beetween the tag <body> and </body>
of an html file */

function lire_contenu ($fichier)
{
   $contenu = lire_fichier ($fichier);
   
   eregi ("<body>([^<]+)</body>",$contenu,$regs);
   
   return($regs[0]);
}

?>
